#! /usr/bin/perl

###########################################################################
# 指定日を表示するモードを提供する
# schedule.cgi に手を入れて作成した。

$maincginame    = "http://raspberrypi/cgi-bin/schedule/schedule.cgi";
$thiscginame    = "today.cgi";


$width_name          = "100";
$color_rowheader_bg  = "#F0F0F0";
$color_name_bg       = "#F0FFF0";


#$color_name_fg  = "#000000";
#$color_wday_fg  = "#000000";
#$color_wday_bg  = "#F0F0F0";
#$color_sat_fg   = "#FFFFFF";
#$color_sat_bg   = "#0000FF";
#$color_sun_fg   = "#FFFFFF";
#$color_sun_bg   = "#FF0000";
#$color_today_fg = "#000000";
#$color_today_bg = "#FFFF80";
#$width_schedule = "300";


###########################################################################
#表示月の設定
$variable = "";
$value = "";
$year = 0;
$mon = 0;
$mday = 0;

$time=time;
($sec,$min,$hour,$today,$thismon,$thisyear,$wday,$yday,$isdaylight)=localtime($time);
$thismon += 1;
$thisyear += 1900;


if($ENV{QUERY_STRING} ne ""){
    @qs = split('&',$ENV{QUERY_STRING});
    foreach $each_qs(@qs){
        ($variable,$value) = split('=',$each_qs);
        if($variable eq "DATE"){
            ($year,$mon,$mday) = split('\+',$value);
            last;
        }
    }
}

$year   =int($year);
$mon    =int($mon);
$mday   =int($mday);

if($year<1999 || $year>2030 || $mon<1 || $mon>12){
    $mon = $thismon;
    $year = $thisyear;
}

if(($mon == $thismon)&&($mday==0 || $mday==99)){
    $mday = $today;
}






###########################################################################
#月初日の曜日を求める(0:SUN 1:MON...)
#  localtime()が返す $wday だと、任意の年月の曜日が取得できないので
#  getweek()サブルーチンを使っている。
$wday = &getweek($year, $mon, $mday);
@weekday=("SUN","MON","TUE","WED","THU","FRI","SAT");


############################################################################
##その月の日数を求める



############################################################################
##その月の日数を求める
$lastday = 31;
if($mon==2){
    if(($year % 400)==0){
        $lastday = 29;
    }elsif(($year % 100)==0){
        $lastday = 28;
    }elsif(($year % 4)==0){
        $lastday = 29;
    }else{
        $lastday = 28;
    }
}else{
    if($mon==4 || $mon==6 ||$mon==9 ||$mon==11){
        $lastday = 30;
    }
}


###########################################################################
#メンバー表の読み込み
open(MEMBER,"member.txt") || die "Open error :$!\n";

@memberlist=<MEMBER>;
@membername;        #メンバー名の配列
@memberpfix;        #メンバーのデータファイルプリフィックスの配列

close MEMBER;

$membercount=0;
foreach $eachmember(@memberlist){
    chomp($eachmember);                   #行末の改行の削除
    @rowdata=split(',',$eachmember);
    if(($rowdata[0] =~ /^\s*$/)||($rowdata[1] =~ /^\s*$/)){  #空白データが見つかったら終了 正規表現は「先頭から末尾まで空白」
        last;
    }
    $membername[$membercount]=$rowdata[0];
    $memberpfix[$membercount]=$rowdata[1];
#    printf("%d:%s --> %s,%s\n",$membercount,$eachmember,$rowdata[0],$rowdata[1]);   #DEBUGPRINT
    $membercount = $membercount+1;
}


###########################################################################
#メンバーのデータの読み込み
@scheduledata;


for($i=0;$i<$membercount;$i++){
    $datfilename = sprintf("%s%04d%02d.txt",$memberpfix[$i],$year,$mon);
    $d=0;
    if(open(DATFILE,$datfilename)){
        @dat=<DATFILE>;
        close DATFILE;
        foreach $eachdat(@dat){
            if($d == $lastday){
                last;
               }
            chomp($eachdat);
            if($eachdat eq ""){
                #$eachdat="&nbsp;";
                $eachdat=" ";
               }
            $scheduledata[$i][$d]=$eachdat;
            $d++;
        }
    }
    while($d < $lastday){
        # $scheduledata[$i][$d]="&nbsp;";
        $scheduledata[$i][$d]=" ";
        $d++;
    }
}


###########################################################################
#表の幅の算出
#$tablewidth = 3 + $width_name + $width_schedule;


###########################################################################
#前の日  次の日へのリンク文字列の作成
# 参考
# http://perldoc.jp/docs/modules/Date-Simple-2.03/Simple.pod
# sudo LC_TIME="C" cpan install Date::Simple

use Date::Simple;
$date_current = Date::Simple->new($year, $mon, $mday);
$prevday = $date_current->prev;
$nextday = $date_current->next;
$prevdaylink = sprintf("%s?DATE=%d+%d+%d",$thiscginame, $prevday->year,$prevday->month, $prevday->day);
$nextdaylink = sprintf("%s?DATE=%d+%d+%d",$thiscginame, $nextday->year,$nextday->month, $nextday->day);



print <<EOF;
content-type: text/html

<HTML>
<HEAD>
<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=UTF-8">
<TITLE>Schedule Viewer</TITLE>
</HEAD>
<BODY BGCOLOR="#FFFFFF">
<FONT SIZE="+2"><B>$year年$mon月$mday日 ($weekday[$wday])のスケジュール表</B></FONT>
&nbsp;&nbsp;&nbsp;&nbsp;
<A HREF="$prevdaylink">前日</A>
&nbsp;&nbsp;&nbsp;&nbsp;
<A HREF="$nextdaylink">次の日</A>
&nbsp;&nbsp;&nbsp;&nbsp;
<A HREF="$maincginame">スケジュールメインページ</A>
<BR>
<BR>

<TABLE BORDER="1" CELLSPACING="0">
<TR bgcolor=$color_rowheader_bg>
<TD WIDTH=$width_name><B>名前</B></TD>
<TD><B>予定&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</B></TD>
</TR>
EOF


# <TABLE BORDER="1" CELLSPACING="0" WIDTH="$tablewidth" style="table-layout: fixed">



for($mbr=0;  $mbr < $membercount; $mbr++){
    $celldata = $scheduledata[$mbr][$mday-1];

    if($celldata ne " "){
        print "<TR>\n";
        printf ("<TD WIDTH=\"%s\" bgcolor=\"%s\"><B>$membername[$mbr]</B></TD>\n<TD>",$width_name,$color_name_bg);

        $celldata =~ s/&/&amp;/g;           #「&」を「&amp;」に置換
        $celldata =~ s/</&lt;/g;            #「<」を「&lt;」に置換
        $celldata =~ s/>/&gt;/g;            #「>」を「&gt;」に置換
        $celldata =~ s/\s/&nbsp;/g;         # 空白文字を「&nbsp;」に置換
        $celldata =~ s/\\\\/$;/g;           #「\\」をいったん「アラーム文字」に置換
        $celldata =~ s/\\n/&nbsp;&nbsp;&nbsp;/g;       #「\n」を「空白3文字」に置換
        $celldata =~ s/\a/\\/g;             #「アラーム文字」を「\」に置換
        printf $celldata;
        printf ("&nbsp;&nbsp;</TD>\n</TR>\n"); #スペースの追加は窮屈に見せないようにするため
    }
}

print <<EOF;
</TABLE>
</BODY>
</HTML>
EOF

exit(0);


##############################################################
# 任意の日の曜日を得る関数
# 下記 WEBページに掲載されていたものを使わせていただきました。
# http://www.tt.rim.or.jp/~canada/comp/cgi/tech/
sub getweek{
    my($year, $month, $day) = @_;
    if ($month == 1 || $month == 2) {
        $year--;
        $month += 12;
    }
    int(
          $year
        + int($year/4)
        - int($year/100)
        + int($year/400)
        + int((13*$month+8)/5)
        + $day
    ) % 7;
}

